;This program checks if the interrupt
;vectors are already installed for
;INT 10h and INT 0xFF, although it
;overwrites its ISR code every time
;it gets installed to reload in case
;an EXE program overwrites the code.
;;



;nasm zulia.asm -o zulia.com

org 100h
bits 16



%ixdefine _x86_Portable__PLATFORMBITS_ 1632    ;This is the best mode for 16-bit 386+
%include "x86.asm"                           ;as it's truly specific to the size
                                             ;we will use in any mode but also
                                             ;lets us use the automatically-sized
                                             ;registers.


;Write text mode ZULIA screen
;;



;If patch is already installed, skip:
;;
;If DWORD at 0000h:10h*4 is == 0x7FFF0004,
;we have already installed it.
;
;Just display the splash.



;Copy interrupt vector.
;It's in format:
;
;Word 0 -- Offset
;Word 1 -- Segment
;;
mov esi,10h*4
xor eax,eax

push ds
pop es

push ds
push word 0
pop ds          ;DS:SI base == 0 (real mode IVT)

mov edi,[esi]      ;Get old IDT vector



;cmp edi,0x7FFF0034
cmp di,_int10h    ;See if our segment offset is already installed
jne .notinstalled

mov byte[es:instmark],1


jmp .already_installed0
.notinstalled:



mov [es:old10h],edi   ;Save in old variable
mov [0xFF<<2],edi   ;Save in INT 0xFF
;mov edi,0x7FFF0034 ;Set new vector
xor edi,edi
push cs
pop di
shl edi,16
mov di,_int10h

mov dword[esi],edi ;Place new pointer


.already_installed0:
pop ds





;cmp byte[es:instmark],1
;je .already_installed1



;Copy patch to destination segment:
;7FFF:0000:
;;
;push es
;
;mov esi,patch10h     ;DS:ESI  == our embedded ISR
;
;push word 0x7FFF     ;ES:EDI - Segment 7FFF:0000
;pop es
;xor edi,edi
;
;mov ecx,patch10h_SZ
;
;
;;Parameter 1 -- WIDEWORD containing the SEG:OFFSET
;;               address of or new ISR
;;
;;Parameter 0 -- Bits 0-7  -- INT number
;;               Bits 8-15 -- new INT number
;
;;push dword 0x7FFF0004
;;push dword 0xFF10
;;call OPCODE__PC__BIOS16__move_interrupt_vector
;
;
;
;
;
;
;;Align REP instruction to DWORD/WIDEWORD
;;to make it faster:
;;;
;  align 4
;  rep movsb
;
;
;pop es







.already_installed1:


cmp byte[es:instmark],1
je .eend

mov ah,0x31
mov al,0
mov dx,9000/16
int 21h



.eend:
mov ax,4C00h
int 21h













instmark db 0







;The order of labels according
;of structure:
;;

align 4
%include "710patch.asm"



;old10h:
;patch10h:
;incbin "710patch.bin"
;patch10h_END:
;patch10h_SZ equ (patch10h_END-patch10h)/10*10








